<?php
/**************************************************************************\
*
*    phpMyClan: phpMyClan is Content Management System designed for Clans
*    that want to transform their website into a powerful toolkit perfect
*    for their continuing survival.
*
*    Copyright (C) 2004  James Mansfield.
*
*    This script is free software; you can redistribute it and/or modify
*    it under the terms of the GNU General Public License as published by
*    the Free Software Foundation; either version 2 of the License, or
*    (at your option) any later version.
*
*    This script is distributed in the hope that it will be useful,
*    but WITHOUT ANY WARRANTY; without even the implied warranty of
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*    GNU General Public License for more details.
*
*    You should have received a copy of the GNU General Public License
*    along with this script; if not, write to the Free Software
*    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*
*    James Mansfield
*    webmaster@pongles.com
*
\**************************************************************************/

/**************************************************************************\
*
*       Filename: functions.php
*       Last Updated: 09 March 2003
*       Description: Contains the main functions used in phpMyClan.
*
*       Notes: Table Rendering, Button Rendering, Form Rendering and Module
*              Loading needs to be rewritten for 2.1.0.
*
\**************************************************************************/

// *** Core Functions ***

// Function: parsePage
//  -> Returns: Array
//  -> Comment: Works out what current page your own by taking into
//  ->          account your user access
function parsePage()
{
        global $c_rgUser,$c_rgPages,$c_rgConfig;

        $p_strPage = $_GET["page"];

        if(checkAccount(ACCESS_ADMIN))
        {
                if($p_strPage == "logout")
                {
                        setcookie("username");
                        setcookie("password");

                        require("templates/".$c_rgUser["template"]."/logout.tpl");
                        exit;
                }
        }

        foreach($c_rgPages as $strLink=>$rgPage)
        {
                if($strLink == $p_strPage && checkAccess($rgPage["access"],$c_rgUser["account"]))
                {
                        return $c_rgPages[$strLink];
                }
        }

        return $c_rgPages[ $c_rgConfig["default"] ];
}

// Function: parseUser
//  -> Returns: Array
//  -> Comment: Checks if your authed and then returns your options
function parseUser()
{
        global $c_rgConfig,$c_rgOptions;

        if($_COOKIE["username"] && $_COOKIE["password"])
        {
                $sqlUser = mysql_query("SELECT * FROM ".MYSQL_USER." WHERE username='".$_COOKIE["username"]."' LIMIT 0,1");
                $rgUserRow = mysql_fetch_array($sqlUser);

                if($_COOKIE["username"] == $rgUserRow["username"] && $_COOKIE["password"] == $rgUserRow["password"])
                {
                        $rgUser = array("id"=>$rgUserRow["id"],"username"=>$rgUserRow["username"],"email"=>$rgUserRow["email"],"account"=>$rgUserRow["account"],"joined"=>$rgUserRow["joined"],"template"=>$rgUserRow["template"]);

                        $sqlOptions = mysql_query("SELECT * FROM ".MYSQL_OPTIONS." ORDER BY type");

                        foreach($c_rgOptions as $rgOption)
                        {
                                $rgUser[ $rgOption["link"] ] = $rgUserRow[ $rgOption["link"] ];
                        }

                        return $rgUser;
                }
                else
                {
                        setcookie("username");
                        setcookie("password");
                        sendHeader();
                }
        }
        else
        {
                if($_POST["login"])
                {
                        $_POST["password"] = md5($_POST["password"]);

                        $sqlUser = mysql_query("SELECT username,password,template FROM ".MYSQL_USER." WHERE username='".$_POST["username"]."' AND password='".$_POST["password"]."' LIMIT 0,1");
                        $rgUserRow = mysql_fetch_array($sqlUser);

                        if($_POST["username"] == $rgUserRow["username"] && $_POST["password"] == $rgUserRow["password"])
                        {
                                if(!checkTemplate($rgUserRow["template"]))
                                {
                                        $rgUserRow["template"] = $c_rgConfig["template"];

                                        mysql_query("UPDATE ".MYSQL_USER." SET template='".$c_rgConfig["template"]."' WHERE username='".$rgUserRow["username"]."'");
                                }

                                setcookie("username",$rgUserRow["username"]);
                                setcookie("password",$rgUserRow["password"]);

                                require("templates/".$rgUserRow["template"]."/login.tpl");
                                exit;
                        }
                        else
                        {
                                sendHeader("index.php?page=login&id=1");
                        }
                }

                return array("username"=>"Guest","account"=>ACCESS_GUEST,"template"=>$c_rgConfig["template"]);
        }
}

// Function: parseLinks
//  -> Returns: String
//  -> Comment: Place all (visible) pages into a string, ready for clicking
function parseLinks()
{
        global $c_rgUser,$c_rgPages;

        foreach($c_rgPages as $strLink=>$rgPage)
        {
                if(is_string($strLink))
                {
                        if(checkAccess($rgPage["access"],$c_rgUser["account"]))
                        {
                                $strLinks .= " - <a href=\"index.php?page=".$strLink."\">".$rgPage["name"]."</a><br>";
                        }
                }
                else
                {
                        $strLinks .= "<p><b>".$rgPage["name"]."</b><br>";
                }
        }

        return $strLinks;
}

// Function: str_delete
//   -> Returns: String
//   -> Comment: Deletes a pattern inside text
function str_delete($strPattern,$strText)
{
        return str_replace($strPattern,"",$strText);
}

// Function: sendHeader
//   -> Returns:
//   -> Comment: Send the user off somewhere else
function sendHeader($strLocation = "index.php")
{
        header("Location: ".$strLocation.$strSuffix);
}

// Function: checkAccess
//  -> Returns: Bool
//  -> Comment: Only used when checking user page access
function checkAccess($iAccess,$iAccount)
{
        if(checkAccount(ACCESS_ADMIN) && $iAccess == ACCESS_HIDDEN)
        {
                return FALSE;
        }

        return $iAccess <= $iAccount;
}

// Function: checkAccount
//  -> Returns: Bool
//  -> Comment: Checks that the current user has the correct access
//              permissions for $iAccess
function checkAccount($iAccess)
{
        global $c_rgUser;

        return $c_rgUser["account"] >= $iAccess;
}

// *** Core Template Functions ***

// Function: getTemplates
//  -> Returns: Array
//  -> Comment: Get the list of directorys inside "templates/"
function getTemplates()
{
        $resTemplate = opendir("templates/");

        while($strEntry = readdir($resTemplate))
        {
                if(is_dir(CW_DIRECTORY."/templates/".$strEntry) && $strEntry != ".." && $strEntry != ".")
                {
                        $rgTemplates[] = $strEntry;
                }
        }

        closedir($resTemplate);

        sort($rgTemplates);

        return $rgTemplates;
}

// Function: parseConfig
//  -> Returns: String
//  -> Comment: Takes the template config, and splits it into an
//  ->          array - array("name"=>NAME,"value"=>VALUE);
function parseConfig($rgFile)
{
        if(is_array($rgFile))
        {
                foreach($rgFile as $strLine)
                {
                        $strLine = trim($strLine);
                        ereg("^([^=.]*)",$strLine,$rgLine);
                        $strLine = str_delete($rgLine[1]."=",$strLine);

                        $rgConfig[ $rgLine[1] ] = $strLine;
                }

                return $rgConfig;
        }
        else
        {
                return FALSE;
        }
}

// Function: checkTemplate
//  -> Returns: Bool
//  -> Comment: Checks that template exists
function checkTemplate($strTemplate)
{
        global $c_rgTemplates;

        return in_array($strTemplate,$c_rgTemplates);
}

// Function: parseTemplate
//  -> Returns: Array
//  -> Comment: Load the template settings and return it as a array
function parseTemplate()
{
        global $c_rgUser;

        $strPath = "templates/".$c_rgUser["template"]."/";

        if(!$rgConfig = parseConfig(file($strPath."config.tpl")))
        {
                return FALSE;
        }

        return $rgConfig;
}

// Function: parseTags
//  -> Returns: String
//  -> Comment: Loops through the tag array and then shoves that into parseTag
function loadTags()
{
        if(file_exists("templates/".$c_rgUser["template"]."/tags.inc"))
        {
                require("templates/".$c_rgUser["template"]."/tags.inc");
        }
}

// Function: parseTags
//  -> Returns: String
//  -> Comment: Loops through the tag array and then shoves that into parseTag
function parseTags($strText)
{
        global $c_rgTags;

        foreach($c_rgTags as $strName => $strValue)
        {
                if(ereg("{".$strName."}",$strText))
                {
                        $strText = parseTag($strText,array("0"=>$strName),$strValue);
                }
        }

        return $strText;
}

// Function: parseTag
//  -> Returns: String
//  -> Comment: Coverts {tag} to what it should be
function parseTag($strText,$rgParent,$rgChild)
{
        if(is_array($rgChild))
        {
                foreach($rgChild as $strName => $strValue)
                {
                        $rgTemp = $rgParent;
                        $rgTemp[] = $strName;

                        $strText = parseTag($strText,$rgTemp,$strValue);
                }

                return $strText;
        }
        else
        {
                foreach($rgParent as $strName)
                {
                        $strString .= "{".$strName."}";
                }

                return str_replace($strString,$rgChild,$strText);
        }
}

// Function: parseError
//  -> Returns: String
//  -> Comment: Coverts any error message into what the template
//              wants
function parseError($strText)
{
        global $c_rgTemplate;

        if($strText)
        {
                $strText = "Error: ".$strText;
        }
        else
        {
                $strText = "Success: Completed";
        }

        return str_replace("{error}",$strText,$c_rgTemplate["error"]);
}

// *** Table Rendering ***

// Function: renderTable
//  -> Returns: String
//  -> Comment: Renders an array as if it was a table
function renderTable($rgRows,$strForm = FALSE,$rgColumns = array("40","60"))
{
        global $c_rgPage;

        if(is_string($strForm))
        {
                $strTable .= "<form method=\"post\" action=\"index.php?page=".$c_rgPage["link"].$strForm."&submit=".SUBMIT_FINAL."\">\n";

                $rgTags[] = array("name"=>"colspan","value"=>count($rgColumns));
                $rgTags[] = array("name"=>"align","value"=>"center");

                $rgRows[] = array(array("value"=>"<input name=\"submit\" type=\"submit\" value=\"Submit\">","color"=>COLOR_NORMAL,"tags"=>$rgTags));
        }

        $strTable .= "<table border=\"0\" width=\"100%\" cellpadding=\"4\">\n";
        $strTable .= "<colgroup>";

        foreach($rgColumns as $strWidth)
        {
                $strTable .= "<col width=\"".$strWidth."%\">";
        }

        $strTable .= "</colgroup>\n";

        foreach($rgRows as $rgRow)
        {
                $strTable .= "<tr>\n";

                $strTable .= renderRow($rgRow);

                $strTable .= "</tr>\n";
        }

        $strTable .= "</table>\n";

        if(is_string($strForm))
        {
                $strTable .= "</form>\n";
        }

        return $strTable;
}

// Function: renderTable
//  -> Returns: String
//  -> Comment: Supplies renderTable with column information
function renderRow($rgRow)
{
        global $c_rgTemplate;

        foreach($rgRow as $rgColumn)
        {
                $rgTags = $rgColumn["tags"];

                if($rgColumn["color"])
                {
                        $rgTags[] = array("name"=>"bgcolor","value"=>$c_rgTemplate[ $rgColumn["color"] ]);
                }

                if(is_array($rgTags))
                {
                        $strTags = renderTags($rgTags);
                }

                $strRow .= "<td".$strTags.">".$rgColumn["value"]."</td>\n";
        }

        return $strRow;
}

// Function: renderTags
//  -> Returns: String
//  -> Comment: Supplies renderRow with a string for HTML tags
function renderTags($rgTags)
{
        foreach($rgTags as $rgTag)
        {
                $strTags .= " ".$rgTag["name"]."=\"".$rgTag["value"]."\"";
        }

        return $strTags;
}

// *** Render Form ***

// Function: renderInput
//  -> Returns: String
//  -> Comment: Renders a "input" box for a form
function renderInput($strValue,$rgTags,$strName,$bReadOnly = FALSE)
{
        global $c_rgTemplate;

        $rgTags[] = array("name"=>"name","value"=>$strName);
        $rgTags[] = array("name"=>"size","value"=>$c_rgTemplate["input"]);

        if($strValue)
        {
                $rgTags[] = array("name"=>"value","value"=>$strValue);
        }

        $strTags = renderTags($rgTags);

        if($bReadOnly)
        {
                $strTags .= " readonly";
        }

        return "<input".$strTags.">";
}

// Function: renderTextarea
//  -> Returns: String
//  -> Comment: Renders a "textarea" box for a form
function renderTextarea($strValue,$rgTags,$strName,$bSmall,$iHeight = 4)
{
        global $c_rgTemplate;

        $iSize = $bSmall ? $c_rgTemplate["s_textarea"] : $c_rgTemplate["l_textarea"];

        $rgTags[] = array("name"=>"name","value"=>$strName);
        $rgTags[] = array("name"=>"rows","value"=>$iHeight);
        $rgTags[] = array("name"=>"cols","value"=>$iSize);

        $strTags = renderTags($rgTags);

        return "<textarea".$strTags.">".$strValue."</textarea>";
}

// Function: renderSelect
//  -> Returns: String
//  -> Comment: Renders a "select" box for a form
function renderSelect($rgTags,$strName,$rgOptions)
{
        $rgTags[] = array("name"=>"name","value"=>$strName);

        $strTags = renderTags($rgTags);

        $strSelect = "\n<select".$strTags.">\n";

        foreach($rgOptions as $rgOption)
        {
                if($rgOption["selected"])
                {
                        $rgOption["selected"] = "selected ";
                }

                if(!$rgOption["name"])
                {
                        $rgOption["name"] = $rgOption["value"];
                }

                $strSelect .= "<option ".$rgOption["selected"]."value=\"".$rgOption["value"]."\">".$rgOption["name"]."</option>\n";
        }

        $strSelect .= "</select>\n";

        return $strSelect;
}

// *** Button Rendering ***

// Function: renderButtons
//  -> Returns: String
//  -> Comment: Renders multiple buttons, centered
function renderButtons($rgButtons)
{
        $strButton .= "<center>";
        
        for($i = 0; $i < sizeof($rgButtons); $i++)
        {
                $strButton .= renderButton($rgButtons[$i]["name"],$rgButtons[$i]["link"]);
                
                // shoot me for the next bit of code ...

                if($i != (count($rgButtons) - 1))
                {
                        $strButton .= "&nbsp;&nbsp;";
                }
        }

        $strButton .= "</center>\n";

        return $strButton;
}

// Function: renderButton
//  -> Returns: String
//  -> Comment: Renders a buttons, not centered
function renderButton($strName,$strLink)
{
        return "[ <a href=\"".$strLink."\">".$strName."</a> ]";
}

// Function: renderButton
//  -> Returns: Array
//  -> Comment: Saves to an array whats required for a "Go Back" button
function renderBack()
{
        return array("name"=>"Go Back","link"=>"javascript:history.go(-1)");
}

// *** Core MySQL Loading ***

// Function: getConfig
//  -> Returns: Array
//  -> Comment: Take EVERYTHING from config table and return it as a array
function getConfig()
{
        global $c_iTime;
        
        $sqlConfig = mysql_query("SELECT name,value FROM ".MYSQL_CONFIG);

        do
        {
                $rgConfig[ $rgConfigRow["name"] ] = $rgConfigRow["value"];

        } while ($rgConfigRow = mysql_fetch_array($sqlConfig));
        
        $c_iTime = mktime() + ($c_rgConfig["time"] * 60 * 60);

        return $rgConfig;
}

function getOptions()
{
        $sqlOptions = mysql_query("SELECT * FROM ".MYSQL_OPTIONS." ORDER BY type");

        do
        {
                if($rgOptionsRow["name"] && $rgOptionsRow["link"] && $rgOptionsRow["type"])
                {
                        $rgOptions[] = array("name"=>$rgOptionsRow["name"],"link"=>$rgOptionsRow["link"],"type"=>$rgOptionsRow["type"]);
                }

        } while ($rgOptionsRow = mysql_fetch_array($sqlOptions));
        
        return $rgOptions;
}

// Function: getText
//  -> Returns: Array
//  -> Comment: Take EVERYTHING from text table and return it as a array
function getText()
{
        $sqlText = mysql_query("SELECT name,value FROM ".MYSQL_TEXT);

        do
        {
                $rgText[ $rgTextRow["name"] ] = $rgTextRow["value"];

        } while ($rgTextRow = mysql_fetch_array($sqlText));

        return $rgText;
}

// *** Misc Functions ***

// Function: parseText
//  -> Returns: String
//  -> Comment: Covert \n's into <br>'s from a query
function parseText($strText)
{
        return nl2br($strText);
}

// Function: parseRandom
//  -> Returns: String
//  -> Comment: parse text to be stuck in a MySQL database
function parseQuery($strText)
{
        $strText = trim($strText);
        $strText = htmlspecialchars($strText);

        return $strText;
}

// Function: parseBBCode
//  -> Returns: String
//  -> Comment: Not using an array like parseSmileys because there is a mixture of
//              str_replace and eregi_replace
function parseBBCode($strText)
{
        $strText = str_replace("[sub]","<sub>",$strText);
        $strText = str_replace("[/sub]","</sub>",$strText);
        $strText = str_replace("[sup]","<sup>",$strText);
        $strText = str_replace("[/sup]","</sup>",$strText);
        $strText = str_replace("[s]","<s>",$strText);
        $strText = str_replace("[/s]","</s>",$strText);
        $strText = str_replace("[b]","<b>",$strText);
        $strText = str_replace("[/b]","</b>",$strText);
        $strText = str_replace("[i]","<i>",$strText);
        $strText = str_replace("[/i]","</i>",$strText);
        $strText = str_replace("[u]","<u>",$strText);
        $strText = str_replace("[/u]","</u>",$strText);
        $strText = str_replace("[*]","<li>",$strText);
        $strText = str_replace("[list]","<ul>",$strText);
        $strText = str_replace("[/list]","</ul>",$strText);
        $strText = str_replace("[code]","<table border=\"0\" align=\"center\" width=\"95%\" cellpadding=\"3\" cellspacing=\"1\"><tbody><tr><td id=\"smallcode\">CODE</td></tr><tr><td id=\"code\"><br>",$strText);
        $strText = str_replace("[/code]","</td></tr></tbody></table>",$strText);
        $strText = eregi_replace("\\[img]([^\\[]*)\\[/img\\]","<img src=\"\\1\">",$strText);
        $strText = eregi_replace("\\[email\\]([^\\[]*)\\[/email\\]", "<a href=\"mailto:\\1\">\\1</a>",$strText);
        $strText = eregi_replace("\\[email=([^\\[]*)\\]([^\\[]*)\\[/email\\]", "<a href=\"mailto:\\1\">\\2</a>",$strText);
        $strText = eregi_replace("\\[url\\]www.([^\\[]*)\\[/url\\]", "<a href=\"http://www.\\1\" target=\"_blank\">\\1</a>",$strText);
        $strText = eregi_replace("\\[url\\]([^\\[]*)\\[/url\\]","<a href=\"\\1\" target=\"_blank\">\\1</a>",$strText);
        $strText = eregi_replace("\\[url=([^\\[]*)\\]([^\\[]*)\\[/url\\]","<a href=\"\\1\" target=\"_blank\">\\2</a>",$strText);

        return $strText;
}

function parseSmileys($strText)
{
        $rgEmoticons[] = array(":mellow:","mellow");
        $rgEmoticons[] = array(":huh:","huh.gif");
        $rgEmoticons[] = array("^_^","happy.gif");
        $rgEmoticons[] = array(":o", "ohmy.gif");
        $rgEmoticons[] = array(":P","ongue.gif");
        $rgEmoticons[] = array(":D","biggrin.gif");
        $rgEmoticons[] = array(":lol:","laugh.gif");
        $rgEmoticons[] = array("B)","cool.gif");
        $rgEmoticons[] = array(":rolleyes:","rolleyes.gif");
        $rgEmoticons[] = array("-_-","sleep.gif");
        $rgEmoticons[] = array("<_<","dry.gif");
        $rgEmoticons[] = array(":)","smile.gif");
        $rgEmoticons[] = array(":wub:","wub.gif");
        $rgEmoticons[] = array(":angry:","mad.gif");
        $rgEmoticons[] = array(":(","sad.gif");
        $rgEmoticons[] = array(":unsure:","unsure.gif");
        $rgEmoticons[] = array(":S","wacko.gif");
        $rgEmoticons[] = array("O_o","blink.gif");
        $rgEmoticons[] = array(":ph34r:","ph34r.gif");
        $rgEmoticons[] = array(";)","wink.gif");
        $rgEmoticons[] = array(":'(","crying.gif");
        $rgEmoticons[] = array(":$","blushing.gif");

        foreach ($rgEmoticons as $rgEmoticon)
        {
                $strText = str_replace($rgEmoticon[0],"<img src=\"images/smileys/".$rgEmoticon[1]." align=\"absmiddle\">",$strText);
        }

        return $strText;
}

// Function: parseLong
//  -> Returns: Integer
//  -> Comment: Chop a string to $iLength and add a ... if nesscercary
function parseLong($strText,$iLength)
{
        $strText = preg_replace("/(?<=^.{".$iLength."}).+$/s","...",$strText);

        return $strText;
}

// Function: parseAccess
//  -> Returns: String
//  -> Comment: Coverts an integer into a string (eg Guest)
function parseAccess($iAccess)
{
        $rgAccess = array("2"=>"Guest","3"=>"Member","4"=>"Admin","5"=>"Webmaster");

        return $rgAccess[$iAccess];
}

// Function: parseType
//  -> Returns: String
//  -> Comment: Coverts an integer into a string (eg Guest)
function parseType($iType)
{
        $rgType = array("1"=>"Input","2"=>"Textarea","3"=>"Select");

        return $rgType[$iType];
}

// Function: parseName
//  -> Returns: String
//  -> Comment: $bSmall when true returns a smaller version of the date
function parseDate($iDate,$strDate = FALSE)
{
        if(!$strDate)
                $strDate = "l, F d, Y";
                
        return date($strDate,$iDate);
}

// Function: checkAccount
//  -> Returns: Bool
//  -> Comment: Checks for a valid email address
function checkEmail($strEmail)
{
        return eregi("^[a-z0-9]+([-_\.]?[a-z0-9])+@[a-z0-9]+([-_\.]?[a-z0-9])+\.[a-z]{2,4}",$strEmail);
}

// Function: parseRandom
//  -> Returns: String
//  -> Comment: Generates a random string
function parseRandom($iLength)
{
        $strPool = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz";
        $iLastChar = strlen($strPool) - 1;

        for($i=0;$i<$iLength;$i++)
        {
                $strRandom .= $strPool[mt_rand(0,$iLastChar)];
        }

        return($strRandom);
}

// Function: parseMail
//  -> Returns: String
//  -> Comment: parse welcome email so I don't have to keep changing design_sub.php if I want to change it
function parseMail($strUser,$strPass)
{
        global $c_rgConfig;

        $strString = str_replace("{username}",$strUser,$c_rgConfig["welcome"]);
        $strString = str_replace("{password}",$strPass,$c_rgConfig["welcome"]);

        return $strString;
}

function parseOption($strOption)
{
        if($strOption)
        {
                return $strOption;
        }
        else
        {
                return "<i>No Information</i>";
        }
}
?>
