<?php
/**************************************************************************\
*
*    phpMyClan: phpMyClan is Content Management System designed for Clans
*    that want to transform their website into a powerful toolkit perfect
*    for their continuing survival.
*
*    Copyright (C) 2004  James Mansfield.
*
*    This script is free software; you can redistribute it and/or modify
*    it under the terms of the GNU General Public License as published by
*    the Free Software Foundation; either version 2 of the License, or
*    (at your option) any later version.
*
*    This script is distributed in the hope that it will be useful,
*    but WITHOUT ANY WARRANTY; without even the implied warranty of
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*    GNU General Public License for more details.
*
*    You should have received a copy of the GNU General Public License
*    along with this script; if not, write to the Free Software
*    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*
*    James Mansfield
*    webmaster@pongles.com
*
\**************************************************************************/

/**************************************************************************\
*
*       Filename: index.php
*       Last Updated: 14 March 2003
*       Description: Core Script for phpMyClan
*
*       Notes: The script crashes when your combine the template loading
*              calls (fopen)
*
\**************************************************************************/

// *** Set Error Control ***
error_reporting(FALSE);

// *** Load MySQL Information ***
require("mysql_config.php");

// *** Check Setup ***
if(defined("FIRSTRUN"))
{
        header ("Location: setup/index.php");
        exit;
}
else
{
        if(is_dir("setup"))
        {
                die("Fatal Error: Please Remove Setup Directory");
        }
}

// *** Load Main Config ***
require("config.php");

// *** Load Functions ***
require("functions.php");

// *** MySQL Setup ***
if(!$resDB = mysql_connect(MYSQL_SERVER,MYSQL_DBUSER,MYSQL_DBPASS))
{
        die("Fatal Error: Cannot Connect to Database");
}

if(!mysql_select_db(MYSQL_DATABASE,$resDB))
{
        die("Fatal Error: Cannot Select Database");
}


// *** Load Config ***
$c_rgConfig = getConfig();

// *** Load Template List ***
$c_rgTemplates = getTemplates();

// *** Load Options ***
$c_rgOptions = getOptions();

// *** Process User ***
$c_rgUser = parseUser();

// *** Process Page ***
$c_rgPage = parsePage();

// *** Load Text ***
$c_rgText = getText();

// *** Load Standard Submit Variables ***
$g_strSubmit = $_GET["submit"];

$g_strAction = $_GET["action"];
$g_iID = $_GET["id"];

// *** Check for Submission ***
if($g_strSubmit == SUBMIT_FINAL)
{
        $strPath = "page/".$c_rgPage["link"]."_sub.php";
        
        if(file_exists($strPath))
        {
                require($strPath);

                for($i = 0; $i < sizeof($c_rgMySQL) && $c_strError == SUBMIT_SUCCESS; $i++)
                {
                        if(!$sqlQuery = mysql_query($c_rgMySQL[$i]))
                        {
                                $c_strError = "Cannot Execute MySQL Query";
                        }
                }

                if($c_strError == SUBMIT_SUCCESS)
                {
                        sendHeader("index.php?page=".$c_rgPage["link"]."&submit=".SUBMIT_SUCCESS);
                }
        }
}

// *** Load Template ***
$strPath = "templates/".$c_rgUser["template"]."/";

/*
I don't have any idea why this code doesn't work ...
if(!($c_rgTemplate = parseTemplate() &&
        $resMain = fopen($strPath."main.tpl","r") &&
        $resTable = fopen($strPath."table.tpl","r")))
{
        die("Fatal Error: Cannot Load Template");
}
*/

if(!$c_rgTemplate = parseTemplate())
{
        die("Fatal Error: Cannot Load Template");
}

if(!$resMain = fopen($strPath."main.tpl","r"))
{
        die("Fatal Error: Cannot Load Template");
}

if(!$resTable = fopen($strPath."table.tpl","r"))
{
        die("Fatal Error: Cannot Load Template");
}

// *** Define Static Tags ***
$c_rgTags["links"] = parseLinks();
$c_rgTags["path"] = "templates/".$c_rgUser["template"];
$c_rgTags["page"] = $c_rgPage;
$c_rgTags["config"] = $c_rgConfig;
$c_rgTags["user"] = $c_rgUser;

// *** Load Custom Tags ***
loadTags();

// *** Start Output Buffer ***
ob_start();

// *** Main Loop ***
while(!feof($resMain))
{
        $strMainData = fgets($resMain,1024);

        if(ereg("{body}",$strMainData))
        {
                $strMainData = str_delete("{body}",$strMainData);

                if($g_strSubmit == SUBMIT_SUCCESS)
                {
                        echo parseError(FALSE);
                }
                elseif($c_strError)
                {
                        echo parseError($c_strError);
                }

                require("page/".$c_rgPage["link"].".php");

                foreach($c_rgTables as $rgTable)
                {
                        if(is_array($rgTable))
                        {
                                while(!feof($resTable))
                                {
                                        $strTableData = fgets($resTable,1024);

                                        if(ereg("{title}",$strTableData))
                                        {
                                                $strTableData = str_replace("{title}",$rgTable["title"],$strTableData);
                                        }
                                        
                                        if(ereg("{main}",$strTableData))
                                        {
                                                $strTableData = str_replace("{main}",$rgTable["main"],$strTableData);
                                        }
                                        
                                        echo $strTableData;
                                }
                        
                                rewind($resTable);
                        }
                        else
                        {
                                echo $rgTable;
                        }
                }
        }

        $strMainData = parseTags($strMainData);

        echo $strMainData;
}

// *** Close Template ***
fclose($resMain);
fclose($resTable);
?>
